#include "list.h"
#define MAXLINELEN 4096
#define SEPARATOR '|'

struct tblptrs
{
  regex_t reg;
  char * to;
};
typedef struct tblptrs tblptr;

void subst(char **, const char *,int, int);
void s(char ** source, char *reg, char * to, int flags);
void so(char ** source, char *reg, char * to, int flags);
void sop(char ** source, regex_t *regcompiled, char * to);
char tochr(char H, char L);
void isodecodtext(char ** source);
void isodecod(char ** source);
void from64(char **string);
inline void findreg_comp(regex_t * regcompiled, char* reg, int flags);
int findreg(char * source, char *reg, int *b, int *e, int flags );
int findregp(char * source, regex_t *regcompiled, int *b, int *e);
int findreg1(char * source, char *reg, int flags);
int findreg1p(char * source, regex_t *regcompiled);
inline int trc(char *source, char, char);
inline void trcs(char **source, char);
void myprint(char* string, tblptr * tableptrs, int listfilelines);
int load_list_file(char * listfile, tblptr ** tableptrs, char** table);
inline int count_lines(char *source);
int extract_boundary_string(struct sitem ** boundary, char * string);
void usage();
void CLI_args(int argc, char** argv);
void inline regexp_error(int err,char *reg);
void read_header(char **header);
void enriched_parsing(char **bufor);
inline void PGP_check_init();
inline int PGP_check(char **bufor);
inline int signature_check(char *bufor);

#define MULTIPART_ALTERNATIVE 1
#define MULTIPART_MIXED 2
#define MULTIPART_DIGEST 3
#define MULTIPART_PARALEL 2       /* equivalent to MIXED */
#define MULTIPART_ENCRYPTED 5
void mimeprocessing();

//FIXME 

const char * regex_errstr[]={
  "",
  "",
  "Invalid pattern.",
  "Not implemented.",
  "Invalid character class name.",
  "Trailing backslash.",
  "Invalid back reference.",
  "Unmatched left bracket.",
  "Parenthesis imbalance.",
  "Unmatched \\{.",
  "Invalid contents of \\{\\}.",
  "Invalid range end.",
  "Ran out of memory.",
  "No preceding re for repetition op."
};
